//+------------------------------------------------------------------+
//|                                                 ChiFunctions.mqh |
//|                                         Copyright 2015, Chistabo |
//|                                               chistabo@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Chistabo"
#property link      "chistabo@gmail.com"
#property strict
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                Chi Functions.mqh |
//|                                          Copyright 2015,Chistabo |
//| SEE END OF CODE FOR LIST OF INCLUDED FUNCTIONS                   |
//+------------------------------------------------------------------+
// http://sites.google.com/site/prof7bit/
#property copyright "Copyright 2015,Chistabo"
#property link      ""
#property strict
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
#import "user32.dll"
int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
#import
//--- PARAMETERS ------------------------------------------------------------------------------------------
string EAName=WindowExpertName();
string TradeSymbol=Symbol();// Currency
string PrintInfo=(EAName+" - "+Symbol()+" at local/broker/GMT time: "+TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES)+" / "+
                  TimeToStr(TimeCurrent(),TIME_MINUTES)+" / "+TimeToStr(TimeGMT(),TIME_MINUTES));
//double RiskPerTrade;
//--- PARAMETERS FOR 'crossedLineS' -----------------------------------------------------------------------
static color CLR_BUY_ARROW=clrDodgerBlue;
static color CLR_SELL_ARROW=clrRed;
static color CLR_CROSSLINE_ACTIVE=Magenta;
static color CLR_CROSSLINE_TRIGGERED = Yellow;
static int STYLE_CROSSLINE_TRIGGERED = STYLE_DASH;
static int STYLE_CROSSLINE_ACTIVE=STYLE_DASH;
static int WIDTH_CROSSLINE_TRIGGERED=1;
static int WIDTH_CROSSLINE_ACTIVE=1;
static bool IS_ECN_BROKER=false;
//+------------------------------------------------------------------+
//| Create the button                                                |
//+------------------------------------------------------------------+
bool ButtonCreate(const long chart_ID=0,const string name="Button",const int sub_window=0,const int x=0,const int y=0,const int width=50,
                  const int height=18,const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER,const string text="Button",const string font="Arial",
                  const int font_size=10,const color clr=clrBlack,const color back_clr=C'236,233,216',const color border_clr=clrNONE,
                  const bool state=false,const bool back=false,const bool selection=false,const bool hidden=true,const long z_order=0)
  {
   ResetLastError(); //--- reset the error value
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0)) //--- create the button
     {
      Print(__FUNCTION__,
            ": failed to create the button! Error code = ",GetLastError());
      return(false);
     }
//--- set button coordinates
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- set button size
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set text font
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set text color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set background color
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//--- set border color
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- set button state
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//--- enable (true) or disable (false) the mode of moving the button by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true); //--- successful execution
  }
//+------------------------------------------------------------------+
//| Delete the button                                                |
//+------------------------------------------------------------------+
bool ButtonDelete(const long chart_ID=0,const string name="Button")
  {
   ResetLastError();
   if(!ObjectDelete(chart_ID,name)) //--- delete the button
     {
      Print(__FUNCTION__,
            ": failed to delete the button! Error code = ",GetLastError());
      return(false);
     }
   return(true); //--- successful execution
  }
//+------------------------------------------------------------------+
//| Create the vertical line                                         |
//+------------------------------------------------------------------+
bool VLineCreate(const long chart_ID=0,const string name="VLine",const int sub_window=0,datetime time=0,const color clr=clrRed,
                 const ENUM_LINE_STYLE style=STYLE_DASHDOT,const int width=1,const bool back=true,const bool selected=true,
                 const bool hidden=false,const long z_order=0)
  {
//--- if the line time is not set,draw it via the last bar
   if(!time)
      time=TimeCurrent();
//--- reset the error value
   ResetLastError();
//--- create a vertical line
   if(!ObjectCreate(chart_ID,name,OBJ_VLINE,sub_window,time,0))
     {
      Print(__FUNCTION__,
            ": failed to create a vertical line! Error code = ",GetLastError());
      return(false);
     }
//--- set line color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set line display style
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//--- set line width
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- mode of moving the line when created
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selected);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selected);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Create a trend line by the given coordinates                     |
//+------------------------------------------------------------------+
bool TLineCreate(const long chart_ID=0,const string name="TrendLine",const int sub_window=0,datetime time1=0,double price1=0,
                 datetime time2=0,double price2=0,const color clr=clrWhite,const ENUM_LINE_STYLE style=STYLE_SOLID,const int width=1,
                 const bool back=false,const bool selected=true,const bool ray_left=false,const bool ray_right=false,const bool hidden=false,
                 const long z_order=0)
  {
//--- reset the error value
   ResetLastError();
//--- create a trend line by the given coordinates
   if(!ObjectCreate(chart_ID,name,OBJ_TREND,sub_window,time1,price1,time2,price2))
     {
      Print(__FUNCTION__,
            ": failed to create a trend line! Error code = ",GetLastError());
      return(false);
     }
//--- set line color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set line display style
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//--- set line width
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the line by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selected);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selected);
//--- enable (true) or disable (false) the mode of continuation of the line's display to the left
   ObjectSetInteger(chart_ID,name,OBJPROP_RAY_LEFT,ray_left);
//--- enable (true) or disable (false) the mode of continuation of the line's display to the right
   ObjectSetInteger(chart_ID,name,OBJPROP_RAY_RIGHT,ray_right);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Trim string                                                      |
//+------------------------------------------------------------------+
string Trim_btn_(string str,string list="btn_")
  {
//--- variable for one character of the Str string
   string ch;
   int Len=StringLen(str);
   int i=0;
//--- loop iteration over all characters of the Str string
   for(;i<Len;i++)
     {
      //--- the next character of the Str string
      ch=StringSubstr(str,i,1);
      //--- if this character is not on the List list,the string should start from this position 
      if(StringFind(list,ch,0)==-1)
        {
         break;// terminate the loop
        }
     }
//--- get the substring and return it
   return(StringSubstr(str,i));
  }
//--- PROF 7bit CODE --------------------------------------------------------------------------------------
//+------------------------------------------------------------------+
//+ Create magic number
//+------------------------------------------------------------------+
/* Create a positive integer for the use as a magic number. The function takes a string as argument and calculates an 31 bit hash value from
* it. The hash does certainly not have the strength of a real cryptographic hash function but it should be more than sufficient for
* generating a unique ID from a string and collisions should not occur. Use it in init() function like this: 
*  magic = makeMagicNumber(WindowExpertName() + Symbol() + Period()); where name would be the name of your EA. EA will then get a unique
* magic number for each instrument and timeframe and this number will always be the same,whenever you put the same EA onto the same chart.
* Numbers generated during testing mode will differ from those numbers generated on a live chart.*/
int makeMagicNumber(string key)
  {
   int i,k;
   int h=0;
   if(IsTesting()){key="_"+key;}
   for(i=0; i<StringLen(key); i++)
     {
      k = StringGetChar(key,i);
      h = h + k;
      h=bitRotate(h,5); // rotate 5 bits
     }
   for(i=0; i<StringLen(key); i++)
     {
      k = StringGetChar(key,i);
      h = h + k;
      h=bitRotate(h,k  &0x0000000F); // rotate depending on character value
     }
   for(i=StringLen(key); i>0; i--) // now we go backwards in our string
     {
      k = StringGetChar(key,i - 1);
      h = h + k;
      h=bitRotate(h,h  &0x0000000F); // rotate depending on the last 4 bits of h
     }
   return(h & 0x7fffffff);
  }
//+------------------------------------------------------------------+
//+ Bit rotate
//+------------------------------------------------------------------+
/* Rotate a 32 bit integer value bit-wise the specified number of bits to the right. This function is needed for calculations in the
* hash function makeMagicNumber() */
int bitRotate(int value,int count)
  {
   int tmp,mask;
   mask=(0x00000001<< count)-1;
   tmp = value & mask;
   value = value >> count;
   value = value | (tmp << (32 - count));
   return(value);
  }
//+------------------------------------------------------------------+
//+ Buy - open order
//+------------------------------------------------------------------+
/* Place a market buy with stop loss,target,magic and Comment; keeps trying in an infinite loop until the position is open.*/
int buy(double lots,double sl,double tp,int magic=42,string comment="")
  {
   int ticket;
   if(!IS_ECN_BROKER)
     {
      return(orderSendReliable (Symbol(),OP_BUY,lots,Ask,100,sl,tp,comment,magic,0,CLR_BUY_ARROW));
        }else{
      ticket=orderSendReliable(Symbol(),OP_BUY,lots,Ask,100,0,0,comment,magic,0,CLR_BUY_ARROW);
      if(sl+tp>0)
        {
         orderModifyReliable(ticket,0,sl,tp,0);
        }
      return(ticket);
     }
  }
//+------------------------------------------------------------------+
//+ Sell - open order
//+------------------------------------------------------------------+
/* Place a market sell with stop loss,target,magic and comment; keeps trying in an infinite loop until the position is open.*/
int sell(double lots,double sl,double tp,int magic=42,string comment="")
  {
   int ticket;
   if(!IS_ECN_BROKER)
     {
      return(orderSendReliable(Symbol(),OP_SELL,lots,Bid,100,sl,tp,comment,magic,0,CLR_SELL_ARROW));
        }else{
      ticket=orderSendReliable(Symbol(),OP_SELL,lots,Bid,100,0,0,comment,magic,0,CLR_SELL_ARROW);
      if(sl+tp>0)
        {
         orderModifyReliable(ticket,0,sl,tp,0);
        }
      return(ticket);
     }
  }
//+------------------------------------------------------------------+
//+ OrderSendReliable
//+------------------------------------------------------------------+
/* Drop-in replacement for OrderSend(). Tries to handle all errors and locks and return only if successful or if the error can not be
* handled or waited for.*/
int orderSendReliable(string symbol,int cmd,double volume,double price,int slippage,double stoploss,double takeprofit,string comment="",
                      int magic=0,datetime expiration=0,color arrow_color=CLR_NONE)
  {
   int ticket;
   int err;
   Print("orderSendReliable ("+symbol+", "+IntegerToString(cmd)+", "+DoubleToString(volume,2)+", "+DoubleToString(price,_Digits)+", "+
         IntegerToString(slippage)+", "+DoubleToString(stoploss,_Digits)+", "+DoubleToString(takeprofit,_Digits)+", "+comment+", "+
         IntegerToString(magic)+", "+TimeToString(expiration,TIME_DATE|TIME_MINUTES)+", "+ColorToString(arrow_color)+")");
   while(true)
     {
      if(IsStopped()){Print("orderSendReliable(): Trading is stopped!");return(-1);}
      RefreshRates();
      if(cmd==OP_BUY)price=Ask;
      if(cmd==OP_SELL)price=Bid;
      if(!IsTradeContextBusy())
        {
         ticket=OrderSend(symbol,cmd,volume,NormalizeDouble(price,_Digits),slippage,NormalizeDouble(stoploss,_Digits),
         NormalizeDouble(takeprofit,_Digits),comment,magic,expiration,arrow_color);
         if(ticket>0)
           {
            Print("orderSendReliable(): Success! Ticket: "+IntegerToString(ticket));
            return(ticket); // normal exit
           }
         err=GetLastError();
         if(isTemporaryError(err))
           {
            Print("orderSendReliable(): Temporary Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". Waiting.");
           }
         else {Print("orderSendReliable(): Permanent Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". Giving up.");return(-1);}
        }
      else {Print("orderSendReliable(): Must wait for trade context");}
      Sleep(MathRand()/10);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//+ Order modify reliable
//+------------------------------------------------------------------+
/* Drop-in replacement for OrderModify(). Tries to handle all errors and locks and return only if successful or if the error can not be
* handled or waited for.*/
bool orderModifyReliable(int ticket,double price,double stoploss,double takeprofit,datetime expiration,color arrow_color=CLR_NONE)
  {
   bool success;
   int err;
   Print("OrderModifyReliable("+IntegerToString(ticket)+", "+DoubleToString(price,_Digits)+", "+DoubleToString(stoploss,_Digits)+", "+
         DoubleToString(takeprofit,_Digits)+", "+TimeToString(expiration,TIME_DATE|TIME_MINUTES)+", "+ColorToString(arrow_color)+")");
   while(True)
     {
      while(IsTradeContextBusy())
        {
         Print("OrderModifyReliable(): Waiting for trade context.");
         Sleep(MathRand()/10);
        }
      success=OrderModify(ticket,NormalizeDouble(price,Digits),NormalizeDouble(stoploss,Digits),NormalizeDouble(takeprofit,Digits),
                          expiration,arrow_color);
      if(success)
        {
         Print("OrderModifyReliable(): Success!");
         return(True);
        }
      err=GetLastError();
      if(isTemporaryError(err))
        {
         Print("orderModifyReliable(): Temporary Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". waiting.");
           }else{
         Print("orderModifyReliable(): Permanent Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". giving up.");
         return(false);
        }
      Sleep(MathRand()/10);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//+ Points per pip (4/5 digit broker)
//+------------------------------------------------------------------+
/* Determine the pip multiplier. Determine the pip multiplier (1 or 10) depending on how many digits the EURUSD symbol has. This is done
* by first finding the exact name of this symbol in the 'symbols.raw' file (it could be EURUSDm or EURUSDiam or any other stupid name
* the broker comes up with only to break other people's code) and then usig MarketInfo() for determining the digits.*/
double pointsPerPip()
  {
   int i;
   int digits;
   double ppp=1;
   string symbol;
   int f=FileOpenHistory("symbols.raw",FILE_BIN|FILE_READ);
   int count=(int)FileSize(f)/1936;
   for(i=0; i<count; i++)
     {
      symbol=FileReadString(f,12);
      if(StringFind(symbol,"EURUSD")!=-1)
        {
         digits=_Digits;
         if(digits==4)ppp=1;
         else ppp=10;
         break;
        }
      FileSeek(f,1924,SEEK_CUR);
     }
   FileClose(f);
   return (ppp);
  }
//+------------------------------------------------------------------+
//+ Get number of open orders
//+------------------------------------------------------------------+
/* Get the number of currently open trades of specified type*/
int getNumOpenOrders(int type,int magic)
  {
   int cnt;
   int num=0;
   int total=OrdersTotal();
   for(cnt=0; cnt<total; cnt++)
     {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
        {
         if((magic==-1 || OrderMagicNumber()==magic) && (type==-1 || OrderType()==type))num++;
        }
     }
   return (num);
  }
//+------------------------------------------------------------------+
//+ Compare two prices
//+------------------------------------------------------------------+
/* Compare two prices. The floating point precision of MT4 can make two seemingly identical values still differ from each other.
* This function will compare two prices after rounding them to the precision that is used for prices (value of Digits).*/
bool isEqualPrice(double a,double b){return(NormalizeDouble(a,Digits)==NormalizeDouble(b,Digits));}
//+------------------------------------------------------------------+
//+ Format order arrow info
//+------------------------------------------------------------------+
/* Create the info-string for opened and closed order arrows.*/
string formatOrderArrowInfo()
  {// order is already selected
   return(StringConcatenate(OrderComment()," (",OrderMagicNumber(),")\nP/L: ",DoubleToStr(OrderProfit()+OrderSwap()+OrderCommission(),2),
          " ",AccountCurrency()," (",DoubleToStr(MathAbs(OrderOpenPrice()-OrderClosePrice())/(MarketInfo(OrderSymbol(),MODE_POINT)*
          pointsPerPip()),2)," pips)"));
  }
//+------------------------------------------------------------------+
//+ Plot closed trade arrow
//+------------------------------------------------------------------+
/* Plot the closing trade arrow. This is part of a re-implementation of what metatrader does when dragging a trade from the history to
* the chart. Metatrader won't do this automatically for manual trading and for pending order fills so we have to do it ourselves.
* See also plotNewOpenTrades() and plotNewClosedTrades() defined below.*/
void plotClosedTradeArrow(int ticket,bool remove=false)
  {
   string name;
   color clr;
   if(IsOptimization())return; //(0)
   if(OrderSelect(ticket,SELECT_BY_TICKET)==true) //Chi added
     {
      name="#"+IntegerToString(ticket)+" ";
      if(OrderType()==OP_BUY){name=name+"buy ";clr=CLR_SELL_ARROW;} // closing a buy is a sell, so make it red
      if(OrderType()==OP_SELL){name=name+"sell ";clr=CLR_BUY_ARROW;} // closing a sell is a buy, so make it blue
      name = name + DoubleToStr(OrderLots(), 2) + " ";
      name = name + OrderSymbol() + " ";
      name = name + "at " + DoubleToStr(OrderOpenPrice(),_Digits) + " ";
      name = name + "close at " + DoubleToStr(OrderClosePrice(),_Digits);
      if(remove)
        {
         ObjectDelete(name);
           } else {
         ObjectCreate(name,OBJ_ARROW,0,OrderCloseTime(),OrderClosePrice());
         ObjectSet(name,OBJPROP_ARROWCODE,3);
         ObjectSet(name,OBJPROP_COLOR,clr);
         ObjectSet(name,OBJPROP_BACK,false);
         ObjectSet(name,OBJPROP_TIMEFRAMES,PERIOD_H1); // Chi - check if works
         ObjectSetText(name,formatOrderArrowInfo());
        }
     } // Chi added
  }
//+------------------------------------------------------------------+
//+ Plot closed trade line
//+------------------------------------------------------------------+
/* Plot the line connecting open and close of a history trade. This is part of a re-implementation of what metatrader does when dragging
* a trade from the history to the chart. Metatrader won't do this automatically for manual trading and for pending order fills so we have
* to do it ourselves. See also plotNewOpenTrades() and plotNewClosedTrades() defined below.*/
void plotClosedTradeLine(int ticket,bool remove=false)
  {
   string name;
   color clr;
   if(IsOptimization())return; // (0)
   if(OrderSelect(ticket,SELECT_BY_TICKET)==true) // Chi if(...)
     {
      name="#"+IntegerToString(ticket)+" ";
      if(OrderType()==OP_BUY)clr=CLR_BUY_ARROW;
      if(OrderType()==OP_SELL)clr=CLR_SELL_ARROW;
      name = name + DoubleToStr(OrderOpenPrice(),_Digits);
      name = name + " -> ";
      name = name + DoubleToStr(OrderClosePrice(),_Digits);
      if(remove)
        {
         ObjectDelete(name);
           } else{
         ObjectCreate(name,OBJ_TREND,0,OrderOpenTime(),OrderOpenPrice(),OrderCloseTime(),OrderClosePrice());
         ObjectSet(name,OBJPROP_RAY,false);
         ObjectSet(name,OBJPROP_STYLE,STYLE_DOT);
         ObjectSet(name,OBJPROP_COLOR,clr);
         ObjectSet(name,OBJPROP_BACK,false); // not in background
         ObjectSet(name,OBJPROP_TIMEFRAMES,PERIOD_H1); // show only in hourly chart
        }
     }
  }
//+------------------------------------------------------------------+
//+ Plot opened trade arrow
//+------------------------------------------------------------------+
/* Plot the opening trade arrow. This is part of a re-implementation of what metatrader does when dragging a trade from the history to
* the chart. Metatrader won't do this automatically for manual trading and for pending order fills so we have to do it ourselves.
* See also plotNewOpenTrades() and plotNewClosedTrades() defined below.*/
void plotOpenedTradeArrow(int ticket,bool remove=false)
  {
   string name,name_wrong;
   color clr;
   if(IsOptimization())return; // (0)
   if(OrderSelect(ticket,SELECT_BY_TICKET)==true) // Chi if(...)
     {
      name="#"+IntegerToString(ticket)+" ";
      if(OrderType()==OP_BUY){name=name+"buy ";clr=CLR_BUY_ARROW;}
      if(OrderType()==OP_SELL){name=name+"sell ";clr=CLR_SELL_ARROW;}
      name = name + DoubleToStr(OrderLots(), 2) + " ";
      name = name + OrderSymbol() + " ";
      // sometimes mt4 will have created an arrow with open price = 0. This is wrong, we will delete it.
      name_wrong=name+"at "+DoubleToStr(0,_Digits);
      name=name+"at "+DoubleToStr(OrderOpenPrice(),_Digits);
      ObjectDelete(name_wrong);
      if(remove)
        {
         ObjectDelete(name);
           } else{
         ObjectCreate(name,OBJ_ARROW,0,OrderOpenTime(),OrderOpenPrice());
         ObjectSet(name,OBJPROP_ARROWCODE,1);
         ObjectSet(name,OBJPROP_COLOR,clr);
         ObjectSet(name,OBJPROP_BACK,false); // not in background
         ObjectSet(name,OBJPROP_TIMEFRAMES,PERIOD_H1); // show only in hourly chart
         ObjectSetText(name,formatOrderArrowInfo());
        }
     }
  }
//+------------------------------------------------------------------+
// Plot new open trades (arrows)
//+------------------------------------------------------------------+
/* Plot all newly opened trades into the chart. Check if the open trade list has changed and plot arrows for opened trades into the chart.
* Metatrader won't do this automatically for manual trading. Use this function for scanning for new trades and plotting them.*/
void plotNewOpenTrades(int magic=-1)
  {
   int total,i;
   if(IsTesting())return; // (0)
   total=OrdersTotal();
   for(i=0; i<total; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true) // Chi if(...)
        {
         if((magic==-1 || OrderMagicNumber()==magic) && OrderSymbol()==Symbol())
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL)
              {
               plotOpenedTradeArrow(OrderTicket());
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| Plot new closed trades (arrows)
//+------------------------------------------------------------------+
/* Plot all newly closed trades into the chart. Check for changes in the trading history and plot the trades into the chart with arrows and
* lines connectimg them. Metatrader won't do this automatically for manual trading. Use this function for scanning for closed trades and
* plotting them.*/
void plotNewClosedTrades(int magic=-1)
  {
   if(IsTesting())return; // (0)
   static int last_change=0;
   bool max_age_defined=GlobalVariableCheck("ARROW_MAX_AGE");
   int max_age = (int)GlobalVariableGet("ARROW_MAX_AGE") * 24 * 60 * 60;
   datetime tc = TimeCurrent();
   bool remove;
   int total,i;
   total=OrdersHistoryTotal();
   if(OrderSelect(total-1,SELECT_BY_POS,MODE_HISTORY)==true) // Chi if(...)
     {
      if(OrderTicket()+max_age+max_age_defined!=last_change)
        {
         last_change=OrderTicket()+max_age+max_age_defined;
         for(i=0; i<total; i++)
           {
            if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true) // Chi if(...)
              {
               if((magic==-1 || OrderMagicNumber()==magic) && OrderSymbol()==Symbol())
                 {
                  if(OrderType()==OP_BUY || OrderType()==OP_SELL)
                    {
                     if(max_age_defined && tc-OrderCloseTime()>max_age)
                       {
                        remove=true;
                          }else{
                        remove=false;
                       }
                     plotOpenedTradeArrow(OrderTicket(),remove);
                     plotClosedTradeArrow(OrderTicket(),remove);
                     plotClosedTradeLine(OrderTicket(),remove);
                    }
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//+ IsTemporaryEror
//+------------------------------------------------------------------+
/* Is the error temporary (does it make sense to wait).*/
bool isTemporaryError(int error)
  {
   return(
          error == ERR_NO_ERROR ||
          error == ERR_COMMON_ERROR ||
          error == ERR_SERVER_BUSY ||
          error == ERR_NO_CONNECTION ||
          error == ERR_MARKET_CLOSED ||
          error == ERR_PRICE_CHANGED ||
          error==ERR_INVALID_PRICE || //happens sometimes
          error == ERR_OFF_QUOTES ||
          error == ERR_BROKER_BUSY ||
          error == ERR_REQUOTE ||
          error == ERR_TRADE_TIMEOUT ||
          error == ERR_TRADE_CONTEXT_BUSY
          );
  }
//+------------------------------------------------------------------+
//| CrossedLineS(tring)
//+------------------------------------------------------------------+
/* Check if a line has been crossed, the line may contain a command string. Return "1" or the argument if price (Bid) just has crossed 
* a line with a description starting with this command or "" otherwise. For example if a line has the description 'buy 0.1' then it will
* return the string "0.1" when price has just crossed it and it will return "" if this is not the case. If the parameter 'one_shot' is true
* (default) it will add the word "triggered: " to the command so it can't be triggered a second time,the line description will then look like
* 'triggered: buy 0.1' and it will not be active anymore. If there is 'bo' [bool???] argument behind the command then it will simply return the
* string "1" if it is triggered. This function is intentionally returning strings and not doubles to enable you to do such funny things like
* for example define a command 'delete' and then have lines like 'delete buy' or 'delete sell' and have it delete other lines once price
* triggers this line or do even more complex "visual programming" in the chart. */
string crossedLineS(string command,bool one_shot=true,color clr_active=CLR_NONE,color clr_triggered=CLR_NONE)
  {
   double last_bid;// see below!
   int i;
   double price;
   string name;
   string command_line;
   string command_argument;
   int type;
   if(clr_active==CLR_NONE)clr_active=CLR_CROSSLINE_ACTIVE;
   if(clr_triggered==CLR_NONE)clr_triggered=CLR_CROSSLINE_TRIGGERED;
   for(i=0;i<ObjectsTotal();i++)
     {
      name=ObjectName(i);
      if(ObjectDescription(name)=="") // is this an object without description (newly created by the user)?
        {
         // Sometimes the user draws a new line and the default color is accidentally the color and style of an active line. If we simply reset
         // all lines without description but with the active color and style we can almost completely eliminate this problem. The color does not
         // influence the functionality in any way but we simply don't WANT to confuse the USER with lines that have  the active color and style
         // that are not active lines.
         if(ObjectGet(name,OBJPROP_COLOR)==clr_active &&
            ObjectGet(name,OBJPROP_WIDTH)==WIDTH_CROSSLINE_ACTIVE &&
            ObjectGet(name,OBJPROP_STYLE)==STYLE_CROSSLINE_ACTIVE)
           {
            ObjectSet(name,OBJPROP_COLOR,clr_triggered);
            ObjectSet(name,OBJPROP_STYLE,STYLE_CROSSLINE_TRIGGERED);
            ObjectSet(name,OBJPROP_WIDTH,WIDTH_CROSSLINE_TRIGGERED);
            ObjectSet(name,OBJPROP_PRICE3,0);
           }
        }
      if(StringFind(ObjectDescription(name),command)==0) // is this an object that contains our command? 
        {
         price=0;
         type=ObjectType(name);
         if(type==OBJ_HLINE)price=ObjectGet(name,OBJPROP_PRICE1); // we only care about certain types of objects
         if(type==OBJ_TREND)price=ObjectGetValueByShift(name,0);
         if(price>0)
           {// we found a line
            // ATTENTION! DIRTY HACK! MAY BREAK IN FUTURE VERSIONS OF MT4 - We store the last bid price in the unused PRICE3 field of every line,
            // so we can call this function more than once per tick for multiple lines. A static variable would not work here since we could not
            // call the function a second time during the same tick
            last_bid=ObjectGet(name,OBJPROP_PRICE3);
            // visually mark the line as an active line
            ObjectSet(name,OBJPROP_COLOR,clr_active);
            ObjectSet(name,OBJPROP_STYLE,STYLE_CROSSLINE_ACTIVE);
            ObjectSet(name,OBJPROP_WIDTH,WIDTH_CROSSLINE_ACTIVE);
            if(last_bid>0) // we have a last_bid value for this line
              {
               if((Close[0]>=price && last_bid<=price) || (Close[0]<=price && last_bid>=price)) // did price cross this line since the last time we checked this line?
                 {
                  command_line=ObjectDescription(name); // extract the argument
                  command_argument=StringSubstr(command_line,StringLen(command)+1);
                  if(command_argument=="")command_argument="1";// default argument is "1"
                  if(one_shot) // make the line triggered if it is a one shot command
                    {
                     ObjectSetText(name,"triggered: "+command_line);
                     ObjectSet(name,OBJPROP_COLOR,clr_triggered);
                     ObjectSet(name,OBJPROP_STYLE,STYLE_CROSSLINE_TRIGGERED);
                     ObjectSet(name,OBJPROP_WIDTH,WIDTH_CROSSLINE_TRIGGERED);
                     ObjectSet(name,OBJPROP_PRICE3,0);
                       }else{
                     ObjectSet(name,OBJPROP_PRICE3,Close[0]);
                    }
                  return(command_argument);
                 }
              }
            ObjectSet(name,OBJPROP_PRICE3,Close[0]); // store current price in the line itself
           }
        }
     }
   return("");// command line not crossed,return empty string (false)
  }
//+------------------------------------------------------------------+
//| CrossedLineD(ouble)
//+------------------------------------------------------------------+
/* Check if a line has been crossed,the line may contain a numeric value. Call 'crossedLineS()' and cast it into a number */
double crossedLineD(string command,bool one_shot=true,color clr_active=CLR_NONE,color clr_triggered=CLR_NONE)
  {
   string arg=crossedLineS(command,one_shot,clr_active,clr_triggered);
   return(StrToDouble(arg));
  }
//+------------------------------------------------------------------+
//| CrossedLine
//+------------------------------------------------------------------+
/* Check if a line has been crossed. Call 'crossedLineS(') and cast it into a bool (true if crossed,otherwise false) */
bool crossedLine(string command,bool one_shot=true,color clr_active=CLR_NONE,color clr_triggered=CLR_NONE)
  {
   string arg=crossedLineS(command,one_shot,clr_active,clr_triggered);
   return(arg != "");
  }
//+------------------------------------------------------------------+
//+ Label create
//+------------------------------------------------------------------+
/* Create a text label.*/
string label(string name,int x,int y,int corner,string text,int size,string font,color clr=Gray,bool selection=false)
  {
   if(!IsOptimization())
     {
      if(name=="")name="label_"+TimeToString(Time[0]);
      if(ObjectFind(name)==-1)ObjectCreate(name,OBJ_LABEL,0,0,0);
      ObjectSet(name,OBJPROP_FONTSIZE,size);
      ObjectSet(name,OBJPROP_COLOR,clr);
      ObjectSet(name,OBJPROP_CORNER,corner);
      ObjectSet(name,OBJPROP_XDISTANCE,x);
      ObjectSet(name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false);
      ObjectSetText(name,text,size,font);
     }
   return(name);
  }
//+------------------------------------------------------------------+
//+ Close all open orders of type
//+------------------------------------------------------------------+
/* Close all open orders that match type and magic number. This function won't return until all positions are closed.
* type = -1 means all types, magic = -1 means all magic numbers*/
void closeOpenOrders(int type,int magic)
  {
   int total,cnt;
   double price;
   color clr;
   int order_type;
   Print("closeOpenOrders("+IntegerToString(type)+","+IntegerToString(magic)+")");
   while(getNumOpenOrders(type,magic)>0)
     {
      while(IsTradeContextBusy()){Print("closeOpenOrders(): waiting for trade context.");Sleep(MathRand()/10);}
      total=OrdersTotal();
      RefreshRates();
      if(type==OP_BUY){price=Bid;clr=CLR_SELL_ARROW;}
      else{price=Ask;clr=CLR_BUY_ARROW;}
      for(cnt=0; cnt<total; cnt++)
        {
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if((type==-1 || OrderType()==type) && (magic==-1 || OrderMagicNumber()==magic))
              {
               if(IsTradeContextBusy())break; // something else is trading too, back to the while loop.
               order_type=OrderType();
               if(order_type==OP_BUYSTOP || order_type==OP_SELLSTOP || order_type==OP_BUYLIMIT || order_type==OP_SELLLIMIT)
                  orderDeleteReliable(OrderTicket());
               else orderCloseReliable(OrderTicket(),OrderLots(),price,999,clr);
               break; // restart the loop from 0
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//+ Order close reliable
//+------------------------------------------------------------------+
/* Drop-in replacement for OrderClose().Try to handle all errors and locks and return only if successful or if the error can not
* be handled or waited for.*/
bool orderCloseReliable(int ticket,double lots,double price,int slippage,color arrow_color=CLR_NONE)
  {
   bool success;
   int err;
   Print("orderCloseReliable()");
   if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true)
     {
      while(true)
        {
         if(IsStopped()){Print("orderCloseReliable(): Trading is stopped!");return(false);}
         RefreshRates();
         if(OrderType()==OP_BUY)price=Bid; // close long at bid
         if(OrderType()==OP_SELL)price=Ask; // close short at ask
         if(!IsTradeContextBusy())
           {
            success=OrderClose(ticket,lots,NormalizeDouble(price,_Digits),slippage,arrow_color);
            if(success){Print("orderCloseReliable(): Success!");return(true);} // normal exit
            err=GetLastError();
            if(isTemporaryError(err))
              {Print("orderCloseReliable(): Temporary Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". waiting.");}
            else{Print("orderCloseReliable(): Permanent Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". giving up.");return(false);}
           }
         else{Print("orderCloseReliable(): Must wait for trade context");}
         Sleep(MathRand()/10);
        }
     }
   return(success);
  }
//+------------------------------------------------------------------+
//+ Order delete reliable
//+------------------------------------------------------------------+
/* Drop-in replacement for OrderDelete(). Tries to handle all errors and locks and return only if successful or if the error can not
be handled or waited for.*/
bool orderDeleteReliable(int ticket)
  {
   bool success;
   int err;
   Print("orderDeleteReliable("+IntegerToString(ticket)+")");
   while(true)
     {
      while(IsTradeContextBusy()){Print("OrderDeleteReliable(): Waiting for trade context.");Sleep(MathRand()/10);}
      success=OrderDelete(ticket);
      if(success){Print("orderDeleteReliable(): success.");return(true);}
      err=GetLastError();
      if(isTemporaryError(err))
        {Print("orderDeleteReliable(): Temporary Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". waiting.");}
      else{Print("orderDeleteReliable(): Permanent Error: "+IntegerToString(err)+" "+ErrorDescription(err)+". giving up.");return(false);}
      Sleep(MathRand()/10);
     }
   return(success);
  }
//+------------------------------------------------------------------+
//+ Get profit P&L
//+------------------------------------------------------------------+
/* Calculate unrealized P&L, belonging to all open trades with this magic number.*/
double getProfit(int magic)
  {
   int cnt;
   double profit=0;
   int total=OrdersTotal();
   for(cnt=0; cnt<total; cnt++)
     {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true) // Chi if(...)
        {
         if(OrderMagicNumber()==magic){profit+=OrderProfit()+OrderSwap()+OrderCommission();}
        }
     }
   return (profit);
  }
//+------------------------------------------------------------------+
//+ Get profit closed
//+------------------------------------------------------------------+
/* Calculate realized P&L resulting from all closed trades with this magic number.*/
double getProfitRealized(int magic)
  {
   int cnt;
   double profit=0;
   int total=OrdersHistoryTotal();
   for(cnt=0; cnt<total; cnt++)
     {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true) // Chi if(...)
        {
         if(OrderMagicNumber()==magic){profit+=OrderProfit()+OrderSwap()+OrderCommission();}
        }
     }
   return (profit);
  }
//+------------------------------------------------------------------+
//+ Get open lots 
//+------------------------------------------------------------------+
/* Get the number of (effective) lots that are curretly open. This will return the effective exposure. Offsetting trades will be
* subtracted. The return value will always be positive. See also getLotsOnTableSigned().*/
double getLotsOnTable(int magic)
  {
   double total_lots=0;
   int i;
   int total_orders=OrdersTotal();
   for(i=0; i<total_orders; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true) // Chi if(...)
        {
         if(OrderMagicNumber()==magic)
           {
            if(OrderType()==OP_BUY)
              {
               total_lots+=OrderLots();
              }
            if(OrderType()==OP_SELL)
              {
               total_lots-=OrderLots();
              }
           }
        }
     }
   total_lots=MathAbs(total_lots);
   return(total_lots);
  }
//+------------------------------------------------------------------+
//+ Get lots on table signed
//+------------------------------------------------------------------+
/* Get the number of (effective) lots that are curretly open. This will return the effective exposure. Offsetting trades will be
* subtracted. Positive means long, negative is short. See also getLotsOnTable().*/
double getLotsOnTableSigned(int magic)
  {
   double total_lots=0;
   int i;
   int total_orders=OrdersTotal();
   for(i=0; i<total_orders; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
        {
         if(OrderMagicNumber()==magic)
           {
            if(OrderType()==OP_BUY)total_lots+=OrderLots();
            if(OrderType()==OP_SELL)total_lots-=OrderLots();
           }
        }
     }
   return(total_lots);
  }
//+------------------------------------------------------------------+
//| Trail the stop loss
//+------------------------------------------------------------------+
/* Loop through all matching open positions and trail their stops. If trailstops is 0 then nothing will be done, a positive number is
* the maximum distance between price and stop, the distance at which the stop is trailed behind price. 'trailstop_slow' is a factor
* that will increase trailing distance when the profit grows. Default 1 is normal trailing stop behaviour.*/
void trailStops(double trailstop,int magic,double trailstop_slow=1)
  {
   int total,cnt,type;
   double op,sl,old_sl;
   bool change;
   if(trailstop!=0)
     {
      total=OrdersTotal();
      for(cnt=0; cnt<total; cnt++)
        {
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderMagicNumber()==magic)
              {
               op=OrderOpenPrice();
               old_sl=OrderStopLoss();
               type=OrderType();
               change=False;
               if(type==OP_BUY){sl=op+(Bid-trailstop-op)/trailstop_slow;if(sl>op && (sl>old_sl || old_sl==0)){change=True;}} // Chi added '(... || old_sl=0)'
               if(type==OP_SELL){sl=op-(op-Ask-trailstop)/trailstop_slow;if(sl<op && (sl<old_sl || old_sl==0)){change=True;}}
               if(change){orderModifyReliable(OrderTicket(),op,sl,OrderTakeProfit(),OrderExpiration());}
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//+ Lock profit (break even?)
//+------------------------------------------------------------------+
/* Lock in the profit after a certain amount of profit is reached. This will place (or move) a stoploss 'min_profit' away from the open
* price as soon as price has moved 'distance' away from this point. If distance is 0 or smaller than the minimum  allowed stop distance
* then it will still behave as if you had specified the minimum allowed stop distance.*/
void lockProfit(double min_profit,int magic,double distance=0)
  {
   int total,cnt,type;
   double op,sl,old_sl;
   bool change;
   total=OrdersTotal();
   for(cnt=0; cnt<total; cnt++)
     {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
        {
         if(OrderMagicNumber()==magic)
           {
            old_sl=OrderStopLoss();
            op=OrderOpenPrice();
            type=OrderType();
            change=False;
            if(type==OP_BUY){sl=op+min_profit;if(Bid>sl+distance && (sl>old_sl || old_sl==0)){change=True;}}
            if(type==OP_SELL){sl=op-min_profit;if(Ask<sl-distance && (sl<old_sl || old_sl==0)){change=True;}}
            if(change){orderModifyReliable(OrderTicket(),op,sl,OrderTakeProfit(),OrderExpiration());}
           }
        }
     }
  }
//---------------------------------------------------------------------------------------------------------

// ----- SET GLOBAL VARIABLES FUNCTION -----
void SetGV(string key,double value) {GlobalVariableSet(EAName+"_"+Symbol()+"_"+key,value);}
// ----- GET GLOBAL VARIABLE FUNCTION -----
double GetGV(string key) {return(GlobalVariableGet(EAName+"_"+Symbol()+"_"+key));}
// ----- MONEY MANAGEMENT - RISK FUNCTION ------
void CheckRisk() {if(RiskPerTrade<0.01 || RiskPerTrade>100) {Alert("Invalid Risk! Change risk settings! 0.01 - 100 only possible."); return;}}
//+------------------------------------------------------------------+
//| get text description                                             |
//+------------------------------------------------------------------+
string OnDeinitReasonText(int reasonCode)
  {
   string text="";
   switch(reasonCode)
     {
      case REASON_ACCOUNT:
         text="Account was changed.";break;
      case REASON_CHARTCHANGE:
         text="Symbol or timeframe was changed.";break;
      case REASON_CHARTCLOSE:
         text="Chart was closed.";break;
      case REASON_PARAMETERS:
         text="EA input parameter was changed.";break;
      case REASON_RECOMPILE:
         text="EA "+__FILE__+" was recompiled.";break;
      case REASON_REMOVE:
         text="EA "+__FILE__+" was removed from chart.";break;
      case REASON_TEMPLATE:
         text="New template was applied to chart.";break;
      default:text="Another reason";
     }
   return text;
  }
//+------------------------------------------------------------------+
//| FUNCTIONS in this collection
//+------------------------------------------------------------------+
/*
bool ButtonCreate(const long chartID,const string btnName,const int subWindow,const int btnPosX,const int btnPosY,
                  const int btnWidth,const int btnHeight,const ENUM_BASE_CORNER btnCorner,
                  const string btnText,const string btnFont,const int btnFontSize,const color btnTxtClr,
                  const color btnBgdClr,const color btnBorClr,const bool btnIsPressed,const bool btnInBgnd,
                  const bool btnCanSelect,const bool btnHiddenFromList,const long btnZOrder)
bool ButtonDelete(long chartID,string btnName)
bool VLineCreate(const long chart_ID=0,const string name="VLine",const int sub_window=0,datetime time=0,const color clr=clrRed,
                 const ENUM_LINE_STYLE style=STYLE_DASHDOT,const int width=1,const bool back=true,const bool selected=true,
                 const bool hidden=false,const long z_order=0)
bool TLineCreate(const long chart_ID=0,const string name="TrendLine",const int sub_window=0,datetime time1=0,double price1=0,
                 datetime time2=0,double price2=0,const color clr=clrWhite,const ENUM_LINE_STYLE style=STYLE_SOLID,const int width=1,
                 const bool back=false,const bool selected=true,const bool ray_left=false,const bool ray_right=false,const bool hidden=false,
                 const long z_order=0)
string Trim_btn_(string str,string list="btn_")
//--- 7bit ------------------------------------------------------------------------------------------------
int makeMagicNumber(string key)
int bitRotate(int value,int count)
int getNumOpenOrders(int type,int magic)
bool isEqualPrice(double a,double b)
int buy(double lots,double sl,double tp,int magic=42,string comment="")
int sell(double lots,double sl,double tp,int magic=42,string comment="")
int orderSendReliable(string symbol,int cmd,double volume,double price,int slippage,double stoploss,double takeprofit,string comment="",
                      int magic=0,datetime expiration=0,color arrow_color=CLR_NONE)
bool orderModifyReliable(int ticket,double price,double stoploss,double takeprofit,datetime expiration,color arrow_color=CLR_NONE)
void plotNewOpenTrades(int magic=-1)
void plotNewClosedTrades(int magic=-1)
void plotOpenedTradeArrow(int ticket,bool remove=false)
string formatOrderArrowInfo()
double pointsPerPip()
void plotClosedTradeArrow(int ticket,bool remove=false)
void plotClosedTradeLine(int ticket,bool remove=false)
string crossedLineS(string command,bool one_shot=true,color clr_active=CLR_NONE,color clr_triggered=CLR_NONE)
double crossedLineD(string command,bool one_shot=true,color clr_active=CLR_NONE,color clr_triggered=CLR_NONE)
bool crossedLine(string command,bool one_shot=true,color clr_active=CLR_NONE,color clr_triggered=CLR_NONE)
void checkOpenPriceInd()
void deleteOpenPriceInd()
void SetGV(string key,double value)
double GetGV(string key)
string label(string name,int x,int y,int corner,string text,int size,string font,color clr=Gray)
void closeOpenOrders(int type,int magic)
bool orderDeleteReliable(int ticket)
bool orderCloseReliable(int ticket,double lots,double price,int slippage,color arrow_color=CLR_NONE)
double getProfitRealized(int magic)
double getProfit(int magic)
//--- 7bit end --------------------------------------------------------------------------------------------
void CheckRisk()
string OnDeinitReasonText(int reasonCode)
-----------------------------------------------------------------------------------------------------------
bool ChartEventObjectCreateGet(bool &result,const long chart_ID=0)
bool ChartEventObjectCreateSet(const bool value,const long chart_ID=0)
*/
//+------------------------------------------------------------------+
//+---------------------------------------------------------------------+
//| Check if messages concerning the event of a graphic object creation |
//| are sent to all mql4 applications on the chart.                     |
//+---------------------------------------------------------------------+
bool ChartEventObjectCreateGet(bool &result,const long chart_ID=0)
  {
//--- prepare the variable to get the property value
   long value;
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_EVENT_OBJECT_CREATE,0,value))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//--- store the value of the chart property in memory
   result=value;
//--- successful execution
   return(true);
  }
//+--------------------------------------------------------------------------+
//| The function enables/disables the mode of sending messages concerning    |
//| the event of a graphic object creation to all mql4 applications on the   |
//| chart.                                                                   |
//+--------------------------------------------------------------------------+
bool ChartEventObjectCreateSet(const bool value,const long chart_ID=0)
  {
   ResetLastError();
//--- set property value
   if(!ChartSetInteger(chart_ID,CHART_EVENT_OBJECT_CREATE,0,value))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
